package com.schbrain.canal.client.event;

import com.alibaba.otter.canal.protocol.CanalEntry;
import com.schbrain.canal.client.utils.DataUtil;

import java.util.Map;

public interface MapCanalEvent extends CanalEvent{

    @Override
    default void onEvent(CanalEntry.Header header,CanalEntry.EventType eventType, CanalEntry.RowData rowData){

        switch (eventType) {
            case INSERT:
                Map<String, Object> data = DataUtil.getCloumData(rowData.getAfterColumnsList());
                onInsert(header,data);
                break;
            case UPDATE:
                Map<String, Object> after = DataUtil.getCloumData(rowData.getAfterColumnsList());
                Map<String, Object> before = DataUtil.getCloumData(rowData.getBeforeColumnsList());
                onUpdate(header,before,after);
                break;
            case DELETE:
                Map<String, Object> delete = DataUtil.getCloumData(rowData.getBeforeColumnsList());
                onDelete(header,delete);
                break;
            default:
                break;
        }
    }

    /**
     * onInsert
     * @param after
     */
    void onInsert(CanalEntry.Header header, Map<String,Object> after);

    /**
     * onUpdate
     * @param after
     */
    void onUpdate(CanalEntry.Header header,Map<String,Object> before,Map<String,Object> after);

    /**
     * onDelete
     * @param after
     */
    void onDelete(CanalEntry.Header header,Map<String,Object> after);
}
